/******************************************************************************
 *                             BASIC SPRITE CLASS                             *
 *                              by Gary Neal, Jr.                             *
 *               garyneal_71@yahoo.com       garyneal@geocities.com           *
 ******************************************************************************/

#ifndef _CSPRITE_HPP
#define _CSPRITE_HPP

#ifndef __cplusplus
#error The Clipping Sprite Class defined in SPRITE.HPP requires C++ to compile.
#endif

#include <mem.h>
#include <alloc.h>
#include "include\vmode.h"
#include "include\sprite.hpp"

class ClipSprite : public Sprite {
protected:
    int startXoff, startYoff;
    int lenXcopy, lenYcopy;

    int minX, minY;
    int maxX, maxY;

public:
    // Member functions

    // Constructors and destructor
    ClipSprite(int w=0, int h=0, unsigned int n=0,
               bool useBG=true, bool ownImages=true);  // Default constructor
    ClipSprite(const ClipSprite &s);                   // Copy constructor

    // Operator overloaders
    ClipSprite &operator=(const ClipSprite &s);        // Assigment operator

    // Gets and Sets the visibility status of the images.
    void Hide(void);
    void Show(void);

    // Sets displayable working area
    void SetDisplayArea(int min_x=0, int min_y=0, int max_x=0, int max_y=0);
};

#endif  /* _CSPRITE_HPP */
