/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * FGRAPH.H -- Floating point graphics.                                      *
 *                                                                           *
 * Graphics functions which use floating point math.                         *
 *                                                                           *
 * by Gary Neal, Jr. -- garyneal@geocities.com                               *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef _FGRAPH_H
#define _FGRAPH_H           /* Prevent further includes */

#include <math.h>           /* Needed for sin and cos functions */
#include "include\vmode.h"  /* Needed for ScreenWidth and ScreenHeight */

extern float angleIncr;

#ifdef __cplusplus
extern "C" {                /* Functions must use C type compilation */
#endif

void Line(int X1, int Y1, int X2, int Y2, unsigned char C);

void Circle(int xOffset, int yOffset, int radius, unsigned char C);

#ifdef __cplusplus
}
#endif

#endif /* _FGRAPH_H */
