/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * PALETTE.H -- Header file for VGA Palette manipulation.                  *
 *                                                                         *
 * by Gary Neal, Jr. -- garyneal@geocities.com                             *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef __PALETTE_H
#define __PALETTE_H

#include <conio.h>                /* Needed for inp and outp functions */
#ifdef __TURBOC__
  #include <alloc.h>              /* Used for malloc and NULL */
#else
  #include <malloc.h>             /* Used for malloc and NULL */
#endif
#include "include\vmode.h"        /* Our video functions */

#ifdef __cplusplus
extern "C" {
#endif

/* VGA Palette Access registers */
#define PALETTE_READ  0x3C7
#define PALETTE_WRITE 0x3C8
#define PALETTE_DATA  0x3C9

/* Color variable for receiving the palette information */
union ColorAttribute {
    long color;                   /* A single variable, cool... */
    struct {
        unsigned char reserved;   /* For future use */
        unsigned char blue;       /* Blue  intensity */
        unsigned char green;      /* Green intensity */
        unsigned char red;        /* Red   intensity */
    } RGB;
};

void SetPalette(int attribute, union ColorAttribute color);

void SetPaletteUsing(union ColorAttribute *color);

union ColorAttribute GetPalette(int attribute);

union ColorAttribute *GetPaletteUsing(union ColorAttribute *color);

#ifdef __cplusplus
}
#endif

#endif  /* __PALETTE_H */
