/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * Video mode header file -- VMODE.H                                         *
 * by Gary Neal, Jr -- garyneal@geocities.com                                *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef _VMODE_H
#define _VMODE_H      /* Prevent multiple inclusions */

#include <dos.h>      /* Required for int86 functionality */

/* Video display definitions */
#define TEXT_MODE  0x03
#define VGA256     0x13
#define NO_SCR_CLR 0x80

/* Define constants for Screen dimensions */
#define ScreenWidth  (unsigned)320
#define ScreenHeight (unsigned)200

/* Define constant for maximum no of colors */
#define ScreenColors (unsigned)256

/* Define address constants for video memory */
#define VIDEO_SEG 0xA000
#define videoMem ((unsigned char far *)(MK_FP(VIDEO_SEG, 0)))

#ifdef __cplusplus    /* This module must be compiled C style */
extern "C" {
#endif  /* __cplusplus */

int SetVideoMode(int mode);
int GetVideoMode(void);

#ifdef __cplusplus    /* This module must be compiled C style */
}
#endif  /* __cplusplus */

/* Create macros */
#define SetPixel(X,Y,C) pokeb(VIDEO_SEG, ((((Y<<2)+Y)<<6) + X), C)
#define GetPixel(X,Y)   peekb(VIDEO_SEG, ((((Y<<2)+Y)<<6) + X))
#define FillScreen(C)   _fmemset(MK_FP(VIDEO_SEG, 0), C, 64000)

/* Alternative SetPixel (use if pokeb is not defined and/or is not a macro) */
/* #define SetPixel(X,Y,C) (*((char far *)MK_FP((VIDEO_SEG),((((Y<<2)+Y)<<6)+X)))=(char)(C)) */

/* Alternative GetPixel (use if peekb is not defined and/or is not a macro) */
/* #define GetPixel(X,Y)   (*((char far *)MK_FP((VIDEO_SEG),((((Y<<2)+Y)<<6)+X)))) */

#endif  /* _VMODE_H */
