/* Video mode header file -- VMODEALT.H
 * by Gary Neal, Jr -- garyneal@geocities.com
 *
 * This file is an alternative for the VMODE.H file
 * that contains the SetPixel and FillScreen macros.
 *
 * If your compiler does not support macros (most do) or
 * if you prefer not to use macros, you can use these files instead.
 * This file has a corresponding VMODEALT.C file in the source directory.
 *
 * To use them, rename these files to VMODE.H and VMODE.C, then compile them
 * to OBJ and replace the VMODE module in the GAMELIB file with the newly
 * generated VMODE.OBJ.
 */

#ifndef _VMODE_H
#define _VMODE_H      /* Prevent multiple inclusions */

#include <dos.h>      /* Required for int86 functionality */

/* Video display definitions */
#define TEXT_MODE 0x03
#define VGA256    0x13

/* Define constants for Screen dimensions */
#define ScreenWidth  (unsigned)320
#define ScreenHeight (unsigned)200

/* Define constant for maximum no of colors */
#define ScreenColors (unsigned)256

/* Define existense of global variable */
extern unsigned char far *videoMem;

#ifdef __cplusplus    /* This module must be compiled C style */
extern "C" {
#endif

int SetVideoMode(int mode);
int GetVideoMode(void);
void SetPixel(int X, int Y, unsigned char C);
void FillScreen(unsigned char C);

#ifdef __cplusplus    /* This module must be compiled C style */
}
#endif

#endif  /* _VMODE_H */
