/* Video mode header file -- VMODE.H
 * by Gary Neal, Jr
 */

#ifndef _VMODE_H
#define _VMODE_H      /* Prevent multiple inclusions */

#include <dos.h>      /* Required for int86 functionality */

/* Video display definitions */
#define TEXT_MODE 0x03
#define VGA256    0x13

/* Define constants for Screen dimensions */
#define ScreenWidth  (unsigned)320
#define ScreenHeight (unsigned)200

/* Define constant for maximum no of colors */
#define ScreenColors (unsigned)256

/* Define existense of global variable */
extern unsigned char far *videoMem;

#ifdef __cplusplus    /* This module must be compiled C style */
extern "C" int SetVideoMode(int mode);
#else
int SetVideoMode(int mode);
#endif  /* __cplusplus */

/* Create macros */
#define SetPixel(X,Y,C) videoMem[((((Y<<2)+Y)<<6) + X)] = C
#define FillScreen(C)   _fmemset(videoMem, C, 64000)

#endif  /* _VMODE_H */
