/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * HELLOPAL.C -- Hello Palette World!                                      *
 *                                                                         *
 * A little twist on the old, worn-out Hello World application.            *
 * Demonstrates the changing of colors via the VGA palette.                *
 *                                                                         *
 * by Gary Neal, Jr. -- garyneal@geocities.com                             *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <dos.h>                   /* Needed for the delay function */
#include <conio.h>                 /* Console specific I-O */
#include <stdlib.h>                /* Needed for rand() function */
#include "include\vmode.h"         /* Our video mode functions */
#include "include\palette.h"       /* Palette functions */

int main(void)
{
    union ColorAttribute color;    /* Declare a color variable */

    directvideo = 0;               /* Conio output goes through BIOS */

    /* Put the screen into Mode 13H */
    if (!SetVideoMode(VGA256)) {
        cputs("Failed to initialize VGA video mode.\r\nAborting...\r\n");
        return 1;
    }

    gotoxy(10, 9);
    cputs("Hello Palette World!");
    gotoxy(2, 13);
    cputs("Press a key and watch me change colors");

    while (kbhit()) getch();       /* Clear the keyboard */
    while (!kbhit());              /* Wait for a key */

    gotoxy(6, 17);
    cputs("Press a key to end this demo");

    while (kbhit()) getch();       /* Clear the keyboard */
    while (!kbhit()) {             /* Wait for a key */
        color.RGB.red   = (rand() % 64);
        color.RGB.green = (rand() % 64);
        color.RGB.blue  = (rand() % 64);
        SetPalette(7, color);
        delay(100);
    }

    while (kbhit()) getch();       /* Clear the keyboard */
    SetVideoMode(TEXT_MODE);       /* Return to text mode */
    return 0;
}
