/* Library source file - VMODE.C
 * by Gary Neal, Jr.
 *
 * Allows us to set the video mode between modes 13h and the text mode.
 * Provides information about mode 13h (height, width, and no of colors).
 * Allows us to set pixels and blank the screen.
 */

#include "include\vmode.h"  /* Header file for this library */

unsigned char far *videoMem = (unsigned char far *)0xA0000000L;

int SetVideoMode(int mode)
{
    union REGS regs;              /* Define register variable */

    regs.x.ax = mode;             /* Set video mode */
    int86(0x10, &regs, &regs);    /* Call interrupt to change the mode */

    regs.x.ax = 0xF00;            /* Get current video mode */
    int86(0x10, &regs, &regs);    /* Call interrupt to get the mode */

    return (mode == regs.h.al);   /* Return change condition */
}
